#include <stdlib.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/mount.h>
#include <linux/cdrom.h>
#include <linux/ucdrom.h>
#include <sys/stat.h>
#include <linux/fd.h>
#include <sys/sysmacros.h>
#include <linux/major.h>
#include <sys/wait.h>

#define	EJECT	1
#define	CLOSE	2
#define SWITCH	3

#define VERSION "0a"

void doversion(char *callname){
	printf("\n%s v %s by Erik Greenwald (br0ke@quakeworld.clipboard.com)\n\n",callname,VERSION);
	exit(1);
	}
void dohelp(char *callname){
	printf("\n%s v %s by Erik Greenwald (br0ke@quakeworld.clipboard.com)\n\n",callname,VERSION);
	printf("Usage: %s [OPTIONS]\n\n",callname);
	printf("Default behavior is -c\n\n");
	printf("Options:\n");
	printf("\t-h\t\tDisplay this help screen\n");
	printf("\t-v\t\tDisplay the version\n");
	printf("\t-e\t\tEject the media\n");
	printf("\t-c\t\tClose the tray\n");
	printf("\t-s\t\tSwitch the cdrom (open, sleep, close)\n\n");
	printf("\n\n");
	exit(1);
	}

	
void main(int argc, char **argv){
	int fd, mmph, act=0;
	char *device, *flags="hH?vVeEcCsS";

	device="/dev/cdrom";			/* fix me please */
	
	while ((mmph=getopt(argc,argv,flags))!=EOF){
		switch(mmph){
			case 'h':
			case 'H':
			case '?':
				dohelp(argv[0]);
				break;
			case 'v':
			case 'V':
				doversion(argv[0]);
				break;
			case 'e':
			case 'E':
				act=EJECT;
				break;
			case 'c':
			case 'C':				
				act=CLOSE;
				break;
			case 's':
			case 'S':
				act=SWITCH;
				break;
			default:
				act=SWITCH;
				break;
			}				/* end switch */
		}					/* end while */
	if(argc==1)act=CLOSE;
	
		
	fd=open(device, O_RDONLY);
	
	ioctl(fd,CDROMEJECT_SW,0);		/* turn off autoeject */

	if(act==0){
		/* is open? is closed? is sucking my %$#@? */
		act=CLOSE;	/* fake it till we fix it *sigh*/
		};
	if(act==CLOSE){
		ioctl(fd,CDROMCLOSETRAY);
		ioctl(fd,CDROMSTOP);		/* else it'll spin and spin */
		};
	if(act==EJECT){
		ioctl(fd,CDROMEJECT);
		};
	if(act==SWITCH){
		ioctl(fd,CDROMEJECT);
		sleep(2);
		ioctl(fd,CDROMCLOSETRAY);
		ioctl(fd,CDROMSTOP);
		};

	close(fd);
	return;
	}
	